/*
CHGCLK.CPP
Nov 2004 saw@SFB7
*/
#include "StdAfx.h"
#include <winioctl.h>
#include "chgclk.h"
#include "sys/gfclk_sys.h"

HANDLE hDevice;
DWORD dwBaseAddress;
DWORD dwBaseFreq;

int InitializeGFClk(void)
{
	char path[MAX_PATH];

	GetCurrentDirectory(MAX_PATH, path);
	strcat(path, "\\gfclk.sys");
	hDevice = LoadDriver("GFClk", path);
	if(hDevice == INVALID_HANDLE_VALUE) return GFCLK_ERR_LOAD;
	dwBaseAddress = GetBaseAddress();
	if(!dwBaseAddress){
		CloseHandle(hDevice);
		UnloadDriver("GFClk");
		return GFCLK_ERR_DITECT;
	}
	dwBaseFreq = ReadPhysicalMemory(dwBaseAddress + 0x101000, 4);
	dwBaseFreq = (dwBaseFreq&0x40) ? 14318 : 13500;
	return 0;
}

void EndGFClk(void){
	CloseHandle(hDevice);
	UnloadDriver("GFClk");
}

//hCõ[hƃnh̎擾
HANDLE LoadDriver(char *drivername, char *driverpath)
{
	char name[MAX_PATH];
	SC_HANDLE schSCManager;
	SC_HANDLE schService;
	HANDLE hdevice;
	DWORD errnum;

	sprintf(name, "\\\\.\\%s", drivername);
    hdevice = CreateFile(name, GENERIC_READ | GENERIC_WRITE,
		0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);

	if(hdevice == INVALID_HANDLE_VALUE){
		if (GetLastError() != ERROR_FILE_NOT_FOUND) {
			printf("CreateFile failed!\n");
			return INVALID_HANDLE_VALUE;
        }
		schSCManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
		if(!schSCManager){
			printf("OpenSCManager failed!\n");
			return INVALID_HANDLE_VALUE;
		}

		schService = CreateService(schSCManager, drivername, drivername,
			SERVICE_ALL_ACCESS, SERVICE_KERNEL_DRIVER, SERVICE_DEMAND_START,
			SERVICE_ERROR_NORMAL, driverpath,
			NULL, NULL, NULL, NULL, NULL);
		if(!schService){
			if(GetLastError() != ERROR_SERVICE_EXISTS){
				printf("CreateService failed! %i");
				CloseServiceHandle(schSCManager);
				return INVALID_HANDLE_VALUE;
			}
			schService = OpenService(schSCManager, drivername, SERVICE_ALL_ACCESS);
			if(!schService){
				printf("OpenService failed! %i\n", GetLastError());
				CloseServiceHandle(schSCManager);
				return INVALID_HANDLE_VALUE;
			}
		}

		if(!StartService(schService, 0, NULL)){
			errnum = GetLastError();
			if(errnum != ERROR_SERVICE_ALREADY_RUNNING){
				printf("StartService failed! %d\n", errnum);
				CloseServiceHandle(schService);
				CloseServiceHandle(schSCManager);
				return INVALID_HANDLE_VALUE;
			}
		}
		CloseServiceHandle(schService);
		CloseServiceHandle(schSCManager);
	    hdevice = CreateFile(name, GENERIC_READ | GENERIC_WRITE,
			0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	}

	return hdevice;
}

//hCoJ
void UnloadDriver(char *drivername)
{
	SC_HANDLE schSCManager;
	SC_HANDLE schService;
	SERVICE_STATUS servicestat;

	schSCManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
	if(!schSCManager){
		printf("OpenSCManager failed! %d\n", GetLastError());
		return;
	}
	schService = OpenService(schSCManager, drivername, SERVICE_ALL_ACCESS);
	if(!schService){
		printf("OpenService failed! %d\n", GetLastError());
		CloseServiceHandle(schSCManager);
		return;
	}
	ControlService(schService, SERVICE_CONTROL_STOP, &servicestat);
	DeleteService(schService);
	CloseServiceHandle(schService);
	CloseServiceHandle(schSCManager);
}

DWORD CalcClock(DWORD pll)
{
	DWORD clk = 0, pll1, pll2, pll3;

	pll1 = (pll >> 8) & 0xff;
	pll2 = pll & 0xff;
	pll3 = (pll >> 16) & 0xff;
	if(pll2) clk = (dwBaseFreq * pll1 / pll2) >> pll3;
	return clk;
}

//RANbNƃNbNǂݏo
void GetNVPLLStatus(NVPLL *core, NVPLL *mem)
{
	DWORD dat;

	dat = ReadPhysicalMemory(dwBaseAddress + 0x68050c, 4);
	WritePhysicalMemory(dwBaseAddress + 0x68050c, 4, dat | 0x500);
	WritePhysicalMemory(dwBaseAddress + 0x6013d4, 2, 0x571f);

	if(core){
		dat = ReadPhysicalMemory(dwBaseAddress + 0x680500, 4);
		core->clock = CalcClock(dat);
		core->pll = dat;
	}
	if(mem){
		dat = ReadPhysicalMemory(dwBaseAddress + 0x680504, 4);
		mem->clock = CalcClock(dat);
		mem->pll = dat;
	}
}

//RANbNƃNbNݒ
void SetNVPLLStatus(const NVPLL *core, const NVPLL *mem)
{
	DWORD dat;

	dat = ReadPhysicalMemory(dwBaseAddress + 0x68050c, 4);
	WritePhysicalMemory(dwBaseAddress + 0x68050c, 4, dat | 0x500);
	WritePhysicalMemory(dwBaseAddress + 0x6013d4, 2, 0x571f);

	if(core) WritePhysicalMemory(dwBaseAddress + 0x680500, 4, core->pll);
	if(mem)  WritePhysicalMemory(dwBaseAddress + 0x680504, 4, mem->pll);
}

//AhXǂݍ
DWORD ReadPhysicalMemory(DWORD address, int size)
{
	PHYSICALRDWR physical;
	DWORD ret = 0;
	DWORD bytesReturned;

    physical.address = (void *)address;
	physical.size = size;
    DeviceIoControl (hDevice, 
                                        (DWORD)GFCLK_READ_MEM, 
                                        &physical, 
                                        sizeof(PHYSICALRDWR), 
                                        &ret,
                                        size,
                                        &bytesReturned,
                                        NULL 
                                        );
	return ret;
}

//AhX֏
void WritePhysicalMemory(DWORD address, int size, DWORD data)
{
	PHYSICALRDWR physical;
	DWORD bytesReturned;
	DWORD dammy;
    physical.address = (void *)address;
	physical.size = size;
	physical.data = data;
    DeviceIoControl (hDevice, 
                                        (DWORD)GFCLK_WRITE_MEM, 
                                        &physical, 
                                        sizeof(PHYSICALRDWR), 
                                        &dammy,
                                        4,
                                        &bytesReturned,
                                        NULL 
                                        );
}

//w肳ꂽNbN𐶐œKPLLp[^vZ
int CalcPLL(DWORD clock, NVPLL *out)
{
	int m,n,p;
	int c,d;
	int bestn,bestm,bestdiff;

	bestn=0;
	bestdiff=clock;

	for(p = 0; clock < 128000; p ++, clock *= 2);

	for(m = 8; m <= 13; m++) {
		c = clock * m;
		n = (c + (dwBaseFreq >> 1)) / dwBaseFreq;
		d = c - (n * dwBaseFreq);
		if( d < 0) d = -d;
		d = d / m;
		if(d < bestdiff){
			bestn = n;
			bestm = m;
			bestdiff = d;
		}
	}

	out->pll = (p << 16) + (bestn << 8) + bestm;
	out->clock = (dwBaseFreq * bestn / bestm) >> p;
	return bestdiff;
}

//rfIJ[h̃x[XAhX߂
DWORD GetBaseAddress(void)
{
	int bus, slot;
	PCICONFIGRDWR pciconf;
	DWORD bytesReturned;
	DWORD buf[5];
	DWORD dat = 0;

	for(bus = 0; bus < 16; bus ++){
		for(slot = 0; slot < 32; slot ++){
			pciconf.bus = bus;
			pciconf.slot = slot;
			pciconf.length = 20;
			DeviceIoControl (hDevice, 
                                        (DWORD)GFCLK_READ_PCICONF, 
                                        &pciconf,
                                        sizeof(PCICONFIGRDWR), 
                                        &buf,
                                        20,
                                        &bytesReturned,
                                        NULL 
                                        );
			if(bytesReturned && (buf[0] & 0xffff) == 0x10de &&
				(buf[2] & 0xffff0000) == 0x03000000)
				return buf[4] & 0xffffff00;
		}
	}
	return 0;
}