/*
GFCLK.CPP
Nov 2004 saw@SFB7
*/
#include "stdafx.h"
#include "resource.h"
#include "chgclk.h"

#define GFCLK_VERSION "GeForce Clock Manager Ver.0.01\nCopyright (C) 2004 SFB7"
#define WM_USER_NOTIFY (WM_USER + 100)
#define IDM_EXIT	1000
#define IDM_VERSION	1001
#define IDM_SETUP	1002

LRESULT CALLBACK WindowFunc(HWND hwnd, UINT message, WPARAM wparam, LPARAM lparam);
BOOL CALLBACK ConfirmDialog(HWND hdwnd, UINT message, WPARAM wparam, LPARAM lparam);
BOOL CALLBACK ClockDialog(HWND hdwnd, UINT message, WPARAM wparam, LPARAM lparam);
BOOL IsD3DLoaded();

HINSTANCE hThisInst;
NVPLL ClockLow, ClockHigh;
DWORD dwPrescale;

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow )
{
	HWND hwnd;
	MSG msg;
	WNDCLASSEX wcl;
	
	hThisInst = hInstance;
	switch(InitializeGFClk()){
	case GFCLK_ERR_LOAD:
		MessageBox(0, "hCo[hł܂B", "G[", MB_OK);
		return 0;
	case GFCLK_ERR_DITECT:
		MessageBox(0, "rfIJ[hoł܂łB", "G[", MB_OK);
		return 0;
	}

	if(FindWindow("GFCLK", "GFCLK")){
		MessageBox(0, "ɋNĂ܂B", "GFCLK", MB_OK);
		return 0;
	}

	InitCommonControls();

	ZeroMemory(&wcl, sizeof(WNDCLASSEX));
	wcl.hInstance = hInstance;
	wcl.lpszClassName = "GFCLK";
	wcl.lpfnWndProc = WindowFunc;
	wcl.cbSize = sizeof(WNDCLASSEX);
	if(!RegisterClassEx(&wcl)) return 0;
	hwnd = CreateWindow("GFCLK", "GFCLK", 0,
		CW_USEDEFAULT, CW_USEDEFAULT, 0, 0,
		HWND_DESKTOP, NULL, hInstance, NULL);

	while(GetMessage(&msg, NULL, 0, 0)){
		if(!IsDialogMessage(hwnd, &msg)){
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
	return msg.wParam;
}

//EBhEvV[W
LRESULT CALLBACK WindowFunc(HWND hwnd,UINT message,WPARAM wparam,LPARAM lparam)
{
	static NOTIFYICONDATA niconl, niconh, niconi;
	static HICON hiconl, hiconh;
	static HMENU hmpopup;
	MENUITEMINFO minfo;
	POINT point;
	char inipath[MAX_PATH], str[64];
	static int mode = 0;
	static UINT expreboot = 0;

	//GNXv[ċNACRo^Ȃ
	if(message == expreboot){
		switch(mode){
		case 0:
			Shell_NotifyIcon(NIM_ADD, &niconl);
			break;
		case 1:
			Shell_NotifyIcon(NIM_ADD, &niconh);
			break;
		case 2:
			Shell_NotifyIcon(NIM_ADD, &niconl);
			break;
		}
		return 0;
	}

	switch(message){
	case WM_DESTROY:
		//I
		KillTimer(hwnd, 1);
		GetCurrentDirectory(MAX_PATH, inipath);
		strcat(inipath, "\\gfclk.ini");
		sprintf(str, "%d", dwPrescale);
		WritePrivateProfileString("nvpll", "prescale", str, inipath);
		sprintf(str, "%d", ClockLow.pll);
		WritePrivateProfileString("nvpll", "lowpll", str, inipath);
		sprintf(str, "%d", ClockHigh.pll);
		WritePrivateProfileString("nvpll", "highpll", str, inipath);

		Shell_NotifyIcon(NIM_DELETE, &niconl);
		Shell_NotifyIcon(NIM_DELETE, &niconh);
		Shell_NotifyIcon(NIM_DELETE, &niconi);
		SetNVPLLStatus(&ClockHigh, NULL);
		EndGFClk();
		PostQuitMessage(0);
		break;
	case WM_CREATE:
		GetCurrentDirectory(MAX_PATH, inipath);
		strcat(inipath, "\\gfclk.ini");
		dwPrescale = GetPrivateProfileInt("nvpll", "prescale", 1, inipath);
		ClockLow.pll = GetPrivateProfileInt("nvpll", "lowpll", 0, inipath);
		ClockHigh.pll = GetPrivateProfileInt("nvpll", "highpll", 0, inipath);
		ClockLow.clock = CalcClock(ClockLow.pll) * dwPrescale;
		ClockHigh.clock = CalcClock(ClockHigh.pll) * dwPrescale;
		//iniȂ珉񓮍mFs
		if(!ClockLow.pll || !ClockHigh.pll){
			GetNVPLLStatus(&ClockHigh, NULL);
			ClockLow = ClockHigh;
			if(!DialogBox(hThisInst, MAKEINTRESOURCE(IDD_CONFIRM), hwnd, ConfirmDialog)){
				MessageBox(hwnd, "s𒆎~܂B", "G[", MB_OK);
				EndGFClk();
				PostQuitMessage(0);
				break;
			}
			DialogBox(hThisInst, MAKEINTRESOURCE(IDD_CLOCK), hwnd, ClockDialog);
		}
		//ACRo^
		niconl.cbSize = sizeof(NOTIFYICONDATA);
		niconl.uID = 1;
		niconl.hWnd = hwnd;
		niconl.uFlags = NIF_MESSAGE | NIF_ICON | NIF_TIP;
		niconl.hIcon = LoadIcon(hThisInst, MAKEINTRESOURCE(IDI_ICON_NOTIFYL));
		niconl.uCallbackMessage = WM_USER_NOTIFY;
		niconh = niconl;
		niconh.hIcon = LoadIcon(hThisInst, MAKEINTRESOURCE(IDI_ICON_NOTIFYH));
		niconi = niconl;
		niconi.hIcon = LoadIcon(hThisInst, MAKEINTRESOURCE(IDI_ICON_NOTIFYI));
		Shell_NotifyIcon(NIM_ADD, &niconl);
		//|bvAbvj[쐬
		hmpopup = CreatePopupMenu();
	    minfo.cbSize     = sizeof(MENUITEMINFO);
		minfo.fMask      = MIIM_TYPE | MIIM_ID;
		minfo.fType      = MFT_STRING;
		minfo.wID        = IDM_EXIT;
		minfo.dwTypeData = TEXT("I");
		InsertMenuItem(hmpopup, 0, TRUE, &minfo);
		minfo.wID        = IDM_VERSION;
		minfo.dwTypeData = TEXT("o[W");
		InsertMenuItem(hmpopup, 0, TRUE, &minfo);
		minfo.wID        = IDM_SETUP;
		minfo.dwTypeData = TEXT("ݒ");
		InsertMenuItem(hmpopup, 0, TRUE, &minfo);
		expreboot = RegisterWindowMessage("TaskbarCreated");
		SetNVPLLStatus(&ClockLow, NULL);
		SetTimer(hwnd, 1, 200, NULL);
		break;
	case WM_USER_NOTIFY:
		//^XNgC̃ACRNbNꂽ
		switch(lparam){
		case WM_LBUTTONDOWN:
			if(mode == 2){
				if(IsD3DLoaded()){
					Shell_NotifyIcon(NIM_MODIFY, &niconh);
					mode = 1;
					SetNVPLLStatus(&ClockHigh, NULL);
				}
				else{
					Shell_NotifyIcon(NIM_MODIFY, &niconl);
					mode = 0;
					SetNVPLLStatus(&ClockLow, NULL);
				}
			}
			else{
				mode = 2;
				Shell_NotifyIcon(NIM_MODIFY, &niconi);
				SetNVPLLStatus(&ClockHigh, NULL);
			}
			break;
		case WM_RBUTTONDOWN:
   			GetCursorPos(&point);
			TrackPopupMenu(hmpopup, TPM_RIGHTALIGN | TPM_BOTTOMALIGN,
				point.x, point.y, 0, hwnd, NULL);
			break;
		}
		break;
	case WM_COMMAND:
		switch(LOWORD(wparam)){
		case IDM_EXIT:
			PostMessage(hwnd, WM_CLOSE, 0, 0);
			break;
		case IDM_VERSION:
			MessageBox(hwnd, GFCLK_VERSION, "o[W", MB_OK);
			break;
		case IDM_SETUP:
			if(DialogBox(hThisInst, MAKEINTRESOURCE(IDD_CLOCK),
				hwnd, ClockDialog)){
				if(mode) SetNVPLLStatus(&ClockHigh, NULL);
				else SetNVPLLStatus(&ClockLow, NULL);
			}
			break;
		}
	case WM_TIMER:
		//Direct3DĎāANbN̐ݒs
		if(mode == 2) break;
		KillTimer(hwnd, 1);
		if(IsD3DLoaded()){
			if(!mode) Shell_NotifyIcon(NIM_MODIFY, &niconh);
			mode = 1;
			SetNVPLLStatus(&ClockHigh, NULL);
		}
		else{
			if(mode) Shell_NotifyIcon(NIM_MODIFY, &niconl);
			mode = 0;
			SetNVPLLStatus(&ClockLow, NULL);
		}
		SetTimer(hwnd, 1, 200, NULL);
		break;
	default:
		return DefWindowProc(hwnd,message,wparam,lparam);
	}
	return 0;
}

//NbNݒ̃_CAO
BOOL CALLBACK ClockDialog(HWND hdwnd, UINT message, WPARAM wparam, LPARAM lparam)
{
	HWND hctlwnd;
	char str[64];
	int clk;
	static NVPLL low, high;

	switch(message){
	case WM_INITDIALOG:
		low = ClockLow;
		high = ClockHigh;
		hctlwnd = GetDlgItem(hdwnd, IDC_SLIDLOW);
		SendMessage(hctlwnd, TBM_SETRANGE, TRUE, MAKELONG(100, 7000));
		SendMessage(hctlwnd, TBM_SETPOS, TRUE, low.clock / 100);
		hctlwnd = GetDlgItem(hdwnd, IDC_SLIDHIGH);
		SendMessage(hctlwnd, TBM_SETRANGE, TRUE, MAKELONG(100, 7000));
		SendMessage(hctlwnd, TBM_SETPOS, TRUE, high.clock / 100);
		PostMessage(hdwnd, WM_HSCROLL, 0, 0);
		return 1;

	case WM_COMMAND:
		switch(LOWORD(wparam)){
		case IDOK:
			ClockLow = low;
			ClockHigh = high;
			EndDialog(hdwnd, 1);
			return 1;
		case IDCANCEL:
			EndDialog(hdwnd, 0);
			return 1;
		}
		break;
	case WM_HSCROLL:
		hctlwnd = GetDlgItem(hdwnd, IDC_SLIDLOW);
		clk = (SendMessage(hctlwnd, TBM_GETPOS, 0, 0) * 100) / dwPrescale;
		CalcPLL(clk, &low);
		low.clock *= dwPrescale;
		sprintf(str, "%.2fMHz", (float)low.clock / 1000);
		hctlwnd = GetDlgItem(hdwnd, IDC_LOWCLK);
		SendMessage(hctlwnd, WM_SETTEXT, 0, (LPARAM)str);
		hctlwnd = GetDlgItem(hdwnd, IDC_SLIDHIGH);
		clk = (SendMessage(hctlwnd, TBM_GETPOS, 0, 0) * 100) / dwPrescale;
		CalcPLL(clk, &high);
		high.clock *= dwPrescale;
		sprintf(str, "%.2fMHz", (float)high.clock / 1000);
		hctlwnd = GetDlgItem(hdwnd, IDC_HIGHCLK);
		SendMessage(hctlwnd, WM_SETTEXT, 0, (LPARAM)str);
		return 1;
	}
	return 0;
}

//NbNmF̃_CAO
BOOL CALLBACK ConfirmDialog(HWND hdwnd, UINT message, WPARAM wparam, LPARAM lparam)
{
	HWND hctlwnd;
	char str[64];

	switch(message){
	case WM_INITDIALOG:
		hctlwnd = GetDlgItem(hdwnd, IDC_CONFCLK);
		sprintf(str, "%.2fMHz", (float)ClockHigh.clock / 1000);
		SendMessage(hctlwnd, WM_SETTEXT, 0, (LPARAM)str);
		return 1;

	case WM_COMMAND:
		switch(LOWORD(wparam)){
		case IDOK:
			EndDialog(hdwnd, 1);
			return 1;
		case IDCANCEL:
			EndDialog(hdwnd, 0);
			return 1;
		case IDC_PRESCALED:
			dwPrescale = 2;
			ClockLow.clock *= 2;
			ClockHigh.clock *= 2;
			EndDialog(hdwnd, 1);
		}
		break;
	}
	return 0;
}

//Direct3D[hĂ邩ׂ
BOOL IsD3DLoaded(void)
{
	HANDLE hproc;
	int i, j;
	DWORD pidarray[1024];
	HMODULE midarray[1024];
	DWORD procs, modules, sum;
	static DWORD prevsum = 0, prevprocs = 0;
	char mname[MAX_PATH];
	static BOOL check;

	EnumProcesses(pidarray, sizeof(pidarray), &procs);
	procs /= 4;
	//񑍃`FbNƏd̂ŁAvZXɕωƂ̂ݒׂ
	sum = 0;
	for(i = 0; i < procs; i ++) sum ^= pidarray[i];
	if(sum == prevsum && procs == prevprocs) return check;
	prevsum = sum;
	prevprocs = procs;

	check = FALSE;

	for(j = 0; j < procs; j ++){
		hproc = OpenProcess(PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, 0, pidarray[j]);
		if(!hproc) continue;
		if(EnumProcessModules(hproc, midarray, sizeof(midarray), &modules)){
			modules /= 4;
			for(i = 0; i < modules; i ++){
				if(GetModuleFileNameEx(hproc, midarray[i], mname, MAX_PATH)){
					PathStripPath(mname);
					if(!StrCmpI(mname, "d3dim.dll")) check = TRUE;
					if(!StrCmpI(mname, "d3d8.dll")) check = TRUE;
					if(!StrCmpI(mname, "d3d9.dll")) check = TRUE;
				}
				if(check) break;
			}
		}
		CloseHandle(hproc);
		if(check) break;
	}
	return check;
}

